﻿;
(function() {
  var version = '6.14.3';
  var urlPrefix = 'js://invoke?';
  var nativeEventPrefix = 'appHostEvent_';
  var proxyUrlPrefix = 'js://proxyInvoke?';

    /**
    var isAndroid = (function() {
        return navigator.userAgent.match( /android/i );
    })();

    某些情况下（如qq破解登陆），userAgent会被人为修改，因此，使用userAgent来判断并不准确，因此这里直接改为true，拷贝时请注意修改符合你自身的形式。

    **/
  var isAndroid = true;

  var appHost = function () {
    this.serialNo = 0;
    this.callbacks = {};

    this.subscribeSerialNo = 0;
    this.subscribeCB = {};
    this.subscribeSerialNo2Type = {};
  };

  appHost.prototype.version = version;

  appHost.prototype.invoke = function(name, param, cb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!cb) {
      this.callbacks[serialNo] = cb;
    }
    if (isAndroid) {
      this.invokeOnAndroid(name, param, this.serialNo);
    } else {
      this.invokeOnIos(name, param, this.serialNo);
    }
  };

  appHost.prototype.invokeOnAndroid = function (name, param, serialNo) {
    var obj = {"name": name, "params": param, "version":version, "serial":serialNo};
    window.AndroidInterface.onRequest(JSON.stringify(obj),false);
  };

  appHost.prototype.invokeOnIos = function (name, param, serialNo) {
    var location = urlPrefix + 'version=' + version + '&name=' + encodeURIComponent(name) + '&param=' + encodeURIComponent(JSON.stringify(param)) + '&serial=' + serialNo;
    window.console.log(location);
    window.location = location;
  };

  appHost.prototype.proxyInvoke = function(product, name, param, cb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!cb) {
      this.callbacks[serialNo] = cb;
    }
    if (isAndroid) {
      this.proxyInvokeOnAndroid(product, name, param, this.serialNo);
    } else {
      this.proxyInvokeOnIos(product, name, param, this.serialNo);
    }
  };

  appHost.prototype.proxyInvokeOnAndroid = function (product, name, param, serialNo) {
    var obj = {"product": product, "name": name, "params": param, "version":version, "serial":serialNo};
    window.AndroidInterface.onRequest(JSON.stringify(obj),true);
  };

  appHost.prototype.proxyInvokeOnIos = function (product, name, param, serialNo) {
    var location = proxyUrlPrefix + 'version=' + version + '&product=' + encodeURIComponent(product) + '&name=' + encodeURIComponent(name) + '&param=' + encodeURIComponent(JSON.stringify(param)) + '&serial=' + serialNo;
    window.console.log(location);
    window.location = location;
  };

  appHost.prototype.onInvokeResult = function(serailNo, param) {
    var cb = this.callbacks[serailNo];
    if (!!!cb) {
        window.console.log("non-existed serail: " + serailNo);
        return;
    }
    delete this.callbacks[serailNo];
    cb(param);
  };

  appHost.prototype.onProxyInvokeResult = function(serailNo, param) {
    var cb = this.callbacks[serailNo];
    if (!!!cb) {
      window.console.log("non-existed serail: " + serailNo);
      return;
    }
      delete this.callbacks[serailNo];
      cb(param);
  };

  appHost.prototype.onNativeCall = function(obj) {
    if (obj) {
      var name = obj["name"];
      var params = obj["params"];
      var ver = obj["version"];
      if ("onInvokeResult" === name) {
        var id = params["serial"];
        delete params["serial"];
        this.onInvokeResult(id, params);
      } else if ("onProxyInvokeResult" === name) {
        var id = params["serial"];
        delete params["serial"];
        this.onProxyInvokeResult(id, params);
      } else if ("trigger" == name) {
        this.event.trigger(params["type"], params["detail"]);
      }
    }
  };

  var appHostEvent = function() {};

  appHostEvent.prototype.on = function(type, cb) {
    document.addEventListener(nativeEventPrefix + type, cb, false);
  };

  appHostEvent.prototype.trigger = function(type, detail) {
    var ev = document.createEvent('Event');
    ev.initEvent(nativeEventPrefix + type, true, true);
    ev.detail = detail;
    document.dispatchEvent(ev);
  };

  appHost.prototype.launchActivity = function (url) {
    this.invoke('launchActivity', {'url' : url});
  };

  appHost.prototype.log = function (msg) {
    this.invoke('log', {'msg' : msg});
  };

  appHost.prototype.dispatch = function(name, param, cb) {
    this.invoke(name, param, cb)
  };

  appHost.prototype.subscribe = function(type, cb) {
    if (!!!cb || !!!type) {
      return;
    }
    ++this.subscribeSerialNo;
    var serialNo = this.subscribeSerialNo;
    this.subscribeCB[serialNo] = cb;
    this.subscribeSerialNo2Type[serialNo] = type;
    var that = this;
    this.invoke(type, {'subscribe':true,'serialNo':serialNo}, null);
    return function() {
      delete that.subscribeCB[serialNo];
      delete that.subscribeSerialNo2Type[serialNo];
      that.invoke(type, {'subscribe':false,'serialNo':serialNo}, null);
    };
  };

  appHost.prototype.subscribeCallback = function(obj) {
    if (obj) {
      var type = obj["type"];
      var detail = obj["detail"];
      var result = this.send(type, detail);
      if (obj["cb"]) {
        this.invoke(obj["cb"], result, function(obj) {})
      }
    }
  };

  appHost.prototype.send = function(type, detail) {
    var result = null;
    for (serialNo in this.subscribeSerialNo2Type) {
      if (type == this.subscribeSerialNo2Type[serialNo]) {
        var cb = this.subscribeCB[serialNo];
        if (!!cb) {
          result = cb(detail);
        }
      }
    }
    return result;
  };

  if (!!!window.appHost) {
    var appHostImp = new appHost;
    appHostImp.event = new appHostEvent;
    window.appHost = appHostImp;
    if (!!!window.console || !!!window.console.log) {
      window.console.log = window.appHost.log;
    }
    if (!!window.appHostOnLoad) {
      window.appHostOnLoad();
    }
    window.MasterBridge = window.appHost;
    if (!!window.MasterBridgeDidLoad) {
      window.MasterBridgeDidLoad();
    }
  }
})();