;(function() {
  var version = '6.11.2';
  var urlPrefix = 'js://invoke';
  var proxyUrlPrefix = 'js://proxyInvoke';
  var nativeEventPrefix = 'appHostEvent_';

  var appHost = function () {
    this.serialNo = 0;
    this.callbacks = {};
  };

  appHost.prototype.version = version;

  appHost.prototype.addIframe = function(id, src) {
      var iframe = document.createElement('iframe');
      iframe.id = "appHost_" + id;
      iframe.src = src;
      iframe.style.display = "none";
      document.body.appendChild(iframe);
  }

  appHost.prototype.removeIframe = function(id) {
      var iframe = document.getElementById("appHost_" + id);
      if (!!iframe && !!iframe.parentElement) {
          iframe.parentElement.removeChild(iframe);
      }
  }

  appHost.prototype.invoke = function(name, param, cb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!cb) {
      this.callbacks[serialNo] = cb;
    }

    var params = {
      "version": version,
      "name": name,
      "param": param,
      "serial": serialNo
    };
    var location = urlPrefix + '?' + encodeURIComponent(JSON.stringify(params));
    window.console.log(location);
    if (!!cb) {
      this.addIframe(serialNo, location);
    } else {
      window.location = location;
    }
  }

  appHost.prototype.proxyInvoke = function(product, name, param, cb) {
    ++this.serialNo;
    var serialNo = this.serialNo;
    if (!!cb) {
        this.callbacks[serialNo] = cb;
    }

    var params = {
      "version": version,
      "name": name,
      "params": param,
      "serial": serialNo
    };
    var location = proxyUrlPrefix + '?' + encodeURIComponent(JSON.stringify(params));;
    window.console.log(location);
    window.location = location;
  }

  appHost.prototype.onInvokeResult = function(serailNo, param) {
    var cb = this.callbacks[serailNo];
    if (!!!cb) {
        return;
    }
    delete this.callbacks[serailNo];
    cb(param);
    this.removeIframe(serailNo);
  }

  var appHostEvent = function() {};

  appHostEvent.prototype.on = function(type, cb) {
    document.addEventListener(nativeEventPrefix + type, cb, false);
  };

  appHostEvent.prototype.trigger = function(type, detail) {
    var ev = document.createEvent('Event');
    ev.initEvent(nativeEventPrefix + type, true, true);
    ev.detail = detail;
    document.dispatchEvent(ev);
  };
  if (!!!window.appHost) {
    var appHost = new appHost;
    appHost.event = new appHostEvent;
    window.appHost = appHost;
    if (!!window.appHostOnLoad) {
      window.appHostOnLoad();
    }
  }
})();